#!/usr/bin/python3
import sys
import configparser

if __name__ == "__main__":
    new_config_file=sys.argv[1]
    old_config_file=sys.argv[2]
    # new_config_file = "/usr/share/kylin-system-updater/unattended-upgrades-policy.conf"
    # old_config_file = "/var/lib/unattended-upgrades/unattended-upgrades-policy.conf"
    config_new=configparser.ConfigParser(allow_no_value=True)
    config_new.optionxform = str
    config_old=configparser.ConfigParser(allow_no_value=True)
    config_old.optionxform = str
    try:
        config_new.read(new_config_file)
        config_old.read(old_config_file)
        for section in config_new.sections():
            if not config_old.has_section(section):
                config_old.add_section(section)
                print("new section %s added"%(section))  
            for option in config_new.options(section):
                if not config_old.has_option(section,option):
                    value = config_new[section][option]
                    config_old.set(section,option,value)
                    print("new option:%s %s"%(option,value))
        with open(old_config_file,'w') as f:
            config_old.write(f)
    except Exception as e:
        print(e)
