#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""enums - Enumerates for apt daemon dbus messages"""

__all__ = (
            #错误枚举
            "ERROR_UPDATE_DEFAULT_FAILED",
            "ERROR_UPDATE_SOURCE_FAILED","ERROR_NETWORK_FAILED","ERROR_NOT_GROUPS_CONFIG","ERROR_SOFTWARE_INDEX_RROKEN",
            "ERROR_NOT_INIT_PACKAGESINFIO","ERROR_READ_IMPORTANTLIST_FAILED","ERROR_RESOLVER_FAILED","ERROR_NOT_UPGRADE_PACKAGES",
            "ERROR_REMOVE_ESSENTIAL_PACKAGES","ERROR_NOT_DISK_SPACE","ERROR_NOT_CONFIGPKG_DEPENDENCIES","ERROR_NOT_SELFPKG_DEPENDENCIES",
            "ERROR_NOT_FIX_SYSTEM","ERROR_READ_LOCAL_DEB","ERROR_LOCAL_DEB_FORMAT","ERROR_INSTALL_DEB_BASE","ERROR_LOAD_CONFIG_FAILED",
            "ERROR_INSTALL_DEB_DPKG","ERROR_INSTALL_DEB_DEPEND","ERROR_INSTALL_DEB_OTHER","ERROR_PURGE_PKG_DPKG","SUCCESS_PURGE_PKG",
            "ERROR_PURGE_PKG_VERIFY","ERROR_PURGE_PKG_TOREMOVE","ERROR_NO_OFFLINE_SOURCE","PRIORITY_UPGRADE_SUCCCESSED","ERROR_SYSTEM_SANITY_FAILED",
            "ERROR_UPDATE_SOURCE_TIMEOUT","ERROR_PROGRAM_EXCEPTION","ERROR_RUN_SCRIPTS_FAILED","ERROR_DEVICE_LOW_BATTERY",
            "ERROR_NO_PACKAGE_CACHE","ERROR_INSTALL_DEB_VERIFY","SUCCESS_INSTALL_DEB","ERROR_INSTALL_DEB_SECURITY","ERROR_NOT_SOURCES_PATH",
            "ERROR_SYSTEM_SANITY_WARNING","ERROR_NOT_NECESSARY_LIB","ERROR_DOWNGRADE_PKGS_LIMIT","ERROR_INSTALL_POWER_OUTAGE","ERROR_INCOMP_THIRDS_PKGS",
            "ERROR_CHECK_UPDATE_TIMEOUT","ERROR_SOURCE_WRITE_DENIED","ERROR_INSTALL_TIMEOUT_FAILED",
            # 方法
            "get_error_description_from_enum", "get_error_string_from_enum", "get_source_name_from_enum", "get_caller_from_enum",
            "get_error_num_from_enum","get_policykit_authority_action_enum",

            #其他静态变量
            "RUNTIME_INSTALL_TYPE","POWEROFF_INSTALL_TYPE","DEFAULT_INSTALL_TYPE","APT_PRIVATE_PATH",
            "INSTALL_DEFAULT_FLAG","INSTALL_FAILED_FALG","INSTALL_SUCCESS_FLAG","APT_STANDARD_PATH",

            "CUSTOMIZED_SYSTEM","CUSTOMIZED_SOURCES","INTERMEDIATE_SYSTEM","STANDARD_SOURCES","STANDARD_SYSTEM"
        )

import gettext
gettext.bindtextdomain('kylin-system-updater', '/usr/share/locale')
gettext.textdomain('kylin-system-updater')
_ = gettext.gettext

from aptdaemon.enums import (
                            ERROR_REPO_DOWNLOAD_FAILED,
                            ERROR_NO_PACKAGE,
                            ERROR_NO_CACHE,
                            EXIT_CANCELLED,
                            ERROR_PACKAGE_MANAGER_FAILED,
                            ERROR_PACKAGE_DOWNLOAD_FAILED,
                            ERROR_DAEMON_DIED,
                            ERROR_CACHE_BROKEN,
                            ERROR_NO_LOCK
                            )

from aptdaemon.enums import get_error_description_from_enum as get_other_error_description_from_enum
from aptdaemon.enums import get_error_string_from_enum as get_other_error_string_from_enum

# 静态变量
RUNTIME_INSTALL_TYPE = "runtime"
POWEROFF_INSTALL_TYPE = "pre-poweroff"
DEFAULT_INSTALL_TYPE = "default"
DEFAULT_EMPTY_CHATACTER = ''
INSTALL_DEFAULT_FLAG = 'none'
INSTALL_FAILED_FALG = 'failed'
INSTALL_SUCCESS_FLAG = 'success'

CUSTOMIZED_SOURCES = "customized-sources"
STANDARD_SOURCES = "standard-sources"

CUSTOMIZED_SYSTEM = "customized-system"
INTERMEDIATE_SYSTEM = "intermediate-system"

STANDARD_SYSTEM = "standard-system"

APT_PRIVATE_PATH = "/etc/kylin-system-updater/apt_private.conf"
APT_STANDARD_PATH = "/etc/kylin-system-updater/apt_standard.conf"

#系统更新的所有枚举
PRIORITY_UPGRADE_SUCCCESSED = "priority-upgrade-successed"

#apt update阶段出现的错误解析
ERROR_PROGRAM_EXCEPTION = "error-program-exception"
ERROR_UPDATE_DEFAULT_FAILED = "error-update-default-failed"
ERROR_NOT_SOURCES_PATH = ERROR_NO_LOCK

ERROR_UPDATE_SOURCE_FAILED = "error-update-source-failed"
ERROR_UPDATE_SOURCE_TIMEOUT = "error-update-source-timeout"
ERROR_SOURCE_WRITE_DENIED = "error-source-write-denied"
ERROR_NETWORK_FAILED = "error-network-failed"
ERROR_NOT_GROUPS_CONFIG = "error-not-groups-config"
ERROR_NOT_CONFIGPKG_DEPENDENCIES = "error-not-configpkg-dependencies"
ERROR_NOT_SELFPKG_DEPENDENCIES = "error-not-selfpkg-dependencies"
ERROR_NOT_FIX_SYSTEM = "error-not-fix-system"
ERROR_LOAD_CONFIG_FAILED = "error-load-config-failed"
ERROR_SYSTEM_SANITY_FAILED = "error-system-snaity-failed"
ERROR_SYSTEM_SANITY_WARNING = "error-system-snaity-warning"
ERROR_NOT_NECESSARY_LIB = "error-not-necessary-lib"
ERROR_DOWNGRADE_PKGS_LIMIT="error-downgrade-pkgs-limit"
ERROR_INCOMP_THIRDS_PKGS="error-incomp-thirds-pkgs"
ERROR_CHECK_UPDATE_TIMEOUT="error-check-update-timeout"

#安装错误
ERROR_SOFTWARE_INDEX_RROKEN = "error-software-index-broken"
ERROR_NOT_INIT_PACKAGESINFIO = "error-not-init-packagesinfo"
ERROR_READ_IMPORTANTLIST_FAILED = "error-read-importantlist-failed"
ERROR_RESOLVER_FAILED = "error-resolver-failed"
ERROR_NOT_UPGRADE_PACKAGES = "error-not-upgrade-packages"
ERROR_REMOVE_ESSENTIAL_PACKAGES = "error-remove-essential-packages"
ERROR_RUN_SCRIPTS_FAILED = "error-run-scripts-failed"
ERROR_NOT_DISK_SPACE = "error-not-disk-space"
ERROR_DEVICE_LOW_BATTERY = "error-device-low-battery"
ERROR_READ_LOCAL_DEB = "error-read-local-deb"
ERROR_LOCAL_DEB_FORMAT = "error-local-deb-format"
ERROR_INSTALL_DEB_BASE = "error-install-deb-base"
ERROR_INSTALL_DEB_VERIFY = "error-install-deb-verify"
ERROR_INSTALL_DEB_SECURITY = "error-install-deb-security"
ERROR_INSTALL_DEB_DPKG = "error-install-deb-dpkg"
ERROR_INSTALL_DEB_DEPEND = "error-install-deb-depend"
SUCCESS_INSTALL_DEB = "success-install-deb"
ERROR_INSTALL_DEB_OTHER = "error-install-deb-other"
SUCCESS_PURGE_PKG = "success-purge-pkg"
ERROR_PURGE_PKG_DPKG = "error-purge-pkg-dpkg"
ERROR_PURGE_PKG_VERIFY = "error-purge-pkg-verify"
ERROR_PURGE_PKG_TOREMOVE = "error-purge-pkg-toremove"
ERROR_INSTALL_POWER_OUTAGE = "error-install-power-outage"
ERROR_INSTALL_TIMEOUT_FAILED = "error-install-timeout-failed"

ERROR_NO_PACKAGE_CACHE = "error-no-package-cache"
ERROR_NO_OFFLINE_SOURCE = "error-no-offline-source"

_STRINGS_ERROR = {
    DEFAULT_EMPTY_CHATACTER: '',
    PRIORITY_UPGRADE_SUCCCESSED: _("Update Manager upgrade is complete, please restart the setting panel before performing the system update."),
    ERROR_DAEMON_DIED: _("Update Manager exception, please restart the setting panel before performing the system update."),

    #update
    ERROR_UPDATE_DEFAULT_FAILED: _("Check for update exceptions!"),
    ERROR_UPDATE_SOURCE_FAILED: _("Check for update exceptions!"),
    ERROR_UPDATE_SOURCE_TIMEOUT: _("Check for update exceptions!"),
    ERROR_NETWORK_FAILED: _("Network anomaly, can't check for updates!"),
    ERROR_READ_IMPORTANTLIST_FAILED: _("Check for update exceptions!"),
    ERROR_SOFTWARE_INDEX_RROKEN: _("Check for update exceptions!"),
    ERROR_NOT_INIT_PACKAGESINFIO: _("Check for update exceptions!"),
    ERROR_NOT_FIX_SYSTEM: _("Check for update exceptions!"),
    ERROR_LOAD_CONFIG_FAILED: _("Check for update exceptions!"),
    ERROR_PROGRAM_EXCEPTION: _("Check for update exceptions!"),
    ERROR_NOT_SOURCES_PATH: _("Check for update exceptions!"),
    ERROR_DOWNGRADE_PKGS_LIMIT: _("Check for update exceptions!"),
    ERROR_SYSTEM_SANITY_FAILED: _("Update conditions not met: Patches do not match"),
    ERROR_SYSTEM_SANITY_WARNING: _("Update conditions not met: Patches do not match"),
    ERROR_NOT_NECESSARY_LIB: _("Check for update exceptions!"),
    ERROR_INCOMP_THIRDS_PKGS: _("Check for update exceptions!"),
    ERROR_CHECK_UPDATE_TIMEOUT: _("Check for update exceptions!"),
    ERROR_SOURCE_WRITE_DENIED: _("Check for update exceptions!"),

    #优先升级
    ERROR_NOT_GROUPS_CONFIG: _("Upgrade configuration acquisition exception."),
    ERROR_NOT_CONFIGPKG_DEPENDENCIES: _("Upgrade configuration acquisition exception."),
    ERROR_NOT_SELFPKG_DEPENDENCIES: _("Priority upgrade status exception."),
    
    #install
    EXIT_CANCELLED: _("Failed to fetch"),
    ERROR_RESOLVER_FAILED: _("Could not calculate the upgrade"),
    ERROR_NOT_UPGRADE_PACKAGES: _("There is an exception in the update package."),
    ERROR_REMOVE_ESSENTIAL_PACKAGES: _("There is an exception in the update package."),
    ERROR_RUN_SCRIPTS_FAILED: _("There is an exception in the update package."),
    ERROR_NOT_DISK_SPACE: _("Disk space is insufficient, please clean the disk and then upgrade"),
    ERROR_DEVICE_LOW_BATTERY: _("If the battery of the device is insufficient, please plug in the power supply before updating the system."),
    ERROR_INSTALL_TIMEOUT_FAILED: _(" "),
    ERROR_READ_LOCAL_DEB:_(" "),
    ERROR_INSTALL_POWER_OUTAGE:_(" "),
    ERROR_LOCAL_DEB_FORMAT:_(" "),
    ERROR_INSTALL_DEB_BASE:_(" "),
    ERROR_INSTALL_DEB_VERIFY:_(" "),
    ERROR_INSTALL_DEB_SECURITY:_(" "),
    ERROR_INSTALL_DEB_DPKG:_(" "),
    ERROR_INSTALL_DEB_DEPEND:_(" "),
    ERROR_CACHE_BROKEN:_(" "),
    SUCCESS_INSTALL_DEB:_(" "),
    ERROR_INSTALL_DEB_OTHER:_(" "),
    SUCCESS_PURGE_PKG:_(" "),
    ERROR_PURGE_PKG_DPKG:_(" "),
    ERROR_PURGE_PKG_VERIFY:_(" "),
    ERROR_PURGE_PKG_TOREMOVE:_(" "),

    ERROR_NO_OFFLINE_SOURCE:_(" "),
    ERROR_NO_PACKAGE_CACHE: _(" ")
    }

_DESCS_ERROR = {
    PRIORITY_UPGRADE_SUCCCESSED: '',
    
    DEFAULT_EMPTY_CHATACTER: '',
    ERROR_PROGRAM_EXCEPTION: _("Program exception, please contact the administrator to solve."),
    #update 
    ERROR_NOT_SOURCES_PATH: _(" "),
    ERROR_UPDATE_SOURCE_FAILED: _("Unable to access the source management server, please try again later"),
    ERROR_UPDATE_SOURCE_TIMEOUT: _("Access to the source management server timed out, please try again later"),
    ERROR_NETWORK_FAILED: _("Please check your network connection and retry."),
    ERROR_NOT_GROUPS_CONFIG: _("Unable to get group configuration package, Please check if the configuration package exists in the software source repository."),
    ERROR_NOT_INIT_PACKAGESINFIO: _("An unresolvable problem occurred while initializing the package."),
    ERROR_SOFTWARE_INDEX_RROKEN: _("Software index is broken") + _("It is impossible to install or remove any software. "
                    "Please use the package manager \"Synaptic\" or run "
                    "\"sudo apt-get install -f\" in a terminal to fix "
                    "this issue at first."),
    ERROR_READ_IMPORTANTLIST_FAILED: _("read important list failed"),
    ERROR_NOT_CONFIGPKG_DEPENDENCIES: _("Unable to install group configuration package, Please check the configuration package related dependencies."),
    ERROR_NOT_SELFPKG_DEPENDENCIES: _("Unable to perform priority upgrade, please check the dependency related to the priority upgrade package."),

    ERROR_DOWNGRADE_PKGS_LIMIT: _("Update patchs do not match and too many downgraded packages."),
    ERROR_LOAD_CONFIG_FAILED: _("The system update configuration file is read abnormally, please check if the system update configuration file format is correct."),
    ERROR_NOT_FIX_SYSTEM: _("The system APT environment is abnormal, please check the system APT environment."),
    ERROR_SYSTEM_SANITY_FAILED: _("The version does not match the patch check."),
    ERROR_SYSTEM_SANITY_WARNING: _(" "),
    ERROR_NOT_NECESSARY_LIB: _("The system necessary library matching failed."),
    ERROR_INCOMP_THIRDS_PKGS: _("Third-party application is not compatible with the patch."),
    ERROR_CHECK_UPDATE_TIMEOUT: _("Check the update timeout, please try again later."),
    ERROR_SOURCE_WRITE_DENIED: _("Write Source file was denied, please repair the file permission."),

    #install
    EXIT_CANCELLED: _("_Cancel Upgrade"),
    ERROR_RESOLVER_FAILED: _("  "),
    ERROR_NOT_UPGRADE_PACKAGES: _("This update cannot detect the upgradeable package."),
    ERROR_REMOVE_ESSENTIAL_PACKAGES: _("You request the removal of a system-essential package."),
    ERROR_RUN_SCRIPTS_FAILED:_("Exceptions to running the check script."),
    ERROR_CACHE_BROKEN:_("The package system is broken, please contact the administrator to solve."),
    ERROR_NOT_DISK_SPACE: _(" "),
    ERROR_DEVICE_LOW_BATTERY: _(" "),
    ERROR_READ_LOCAL_DEB:_("Deb format exception, read local deb file error."),
    ERROR_LOCAL_DEB_FORMAT:_("Deb format exception, failed to parse package file."),
    ERROR_INSTALL_DEB_BASE:_("Install deb error."),
    ERROR_INSTALL_POWER_OUTAGE: _("The installation process is abnormally shut down or down."),
    ERROR_INSTALL_DEB_VERIFY:_(" "),
    ERROR_INSTALL_DEB_SECURITY:_(" "),
    ERROR_INSTALL_DEB_DPKG:_(" "),
    ERROR_INSTALL_DEB_DEPEND:_(" "),
    SUCCESS_INSTALL_DEB:_(" "),
    ERROR_INSTALL_DEB_OTHER:_(" "),
    SUCCESS_PURGE_PKG:_(" "),
    ERROR_PURGE_PKG_DPKG:_(" "),
    ERROR_PURGE_PKG_VERIFY:_(" "),
    ERROR_PURGE_PKG_TOREMOVE:_(" "),
    ERROR_NO_OFFLINE_SOURCE:_("If the offline source is not detected, please remount it and update it."),

    ERROR_NO_PACKAGE_CACHE: _("Package is not in cache"),
    ERROR_INSTALL_TIMEOUT_FAILED: _("Installation timeout and the installation is exited.")
    }

_CODE_ERROR = {
    DEFAULT_EMPTY_CHATACTER: '',
    # other 仅测试使用
    ERROR_PROGRAM_EXCEPTION: "#0000",
    ERROR_RESOLVER_FAILED:"#0001",

    #update 
    ERROR_UPDATE_SOURCE_FAILED: "#0100",
    ERROR_UPDATE_SOURCE_TIMEOUT: "#0101",
    ERROR_NETWORK_FAILED: "#0102",
    ERROR_NOT_GROUPS_CONFIG: "#0107",
    ERROR_NOT_INIT_PACKAGESINFIO: "#0108",
    ERROR_SOFTWARE_INDEX_RROKEN: "#0109",
    ERROR_READ_IMPORTANTLIST_FAILED: "#0110",
    ERROR_NOT_CONFIGPKG_DEPENDENCIES: "#0111",
    ERROR_NOT_SELFPKG_DEPENDENCIES: "#0112",
    ERROR_LOAD_CONFIG_FAILED: "#0113",
    ERROR_NOT_FIX_SYSTEM: "#0114",
    ERROR_REPO_DOWNLOAD_FAILED: "#0115",
    ERROR_NO_CACHE: "#0116",
    ERROR_SYSTEM_SANITY_FAILED: "#0117",
    ERROR_SYSTEM_SANITY_WARNING: "#0118",
    ERROR_NOT_NECESSARY_LIB:"#0119",
    ERROR_INCOMP_THIRDS_PKGS:"#0120",
    ERROR_CHECK_UPDATE_TIMEOUT:"#0121",
    ERROR_SOURCE_WRITE_DENIED:"#0122",

    #install
    ERROR_PACKAGE_MANAGER_FAILED: "#0200",
    ERROR_NOT_UPGRADE_PACKAGES: "#0201",
    ERROR_REMOVE_ESSENTIAL_PACKAGES: "#0202",
    ERROR_PACKAGE_DOWNLOAD_FAILED: "#0203",
    ERROR_NOT_DISK_SPACE: "#0204",
    ERROR_READ_LOCAL_DEB: "#0205",
    ERROR_LOCAL_DEB_FORMAT: "#0206",
    ERROR_INSTALL_DEB_BASE: "#0207",
    ERROR_DEVICE_LOW_BATTERY: "#0208",
    ERROR_NO_PACKAGE: "#0209",
    ERROR_NO_PACKAGE_CACHE: "#0210",
    ERROR_INSTALL_DEB_VERIFY:"#0211",
    ERROR_INSTALL_DEB_SECURITY:"#0212",
    ERROR_INSTALL_DEB_DPKG:"#0213",
    ERROR_INSTALL_DEB_DEPEND:"#0214",
    ERROR_CACHE_BROKEN:"#0215",
    ERROR_NO_OFFLINE_SOURCE:"#0216",
    ERROR_INSTALL_POWER_OUTAGE:"#0217",
    ERROR_INSTALL_TIMEOUT_FAILED: "#0218",

    SUCCESS_INSTALL_DEB:"#0219",
    ERROR_INSTALL_DEB_OTHER:"#0220",
    ERROR_PURGE_PKG_DPKG:"#0221",
    ERROR_PURGE_PKG_VERIFY:"#0222",
    ERROR_PURGE_PKG_TOREMOVE:"#0223",
    SUCCESS_PURGE_PKG:"#0230",

    # other 
    EXIT_CANCELLED: "#0300"
    }


#UPGRADE MONITOR STATUS
MONIT_DETECT = "step-updatedetect"
MONIT_DEPRESOLUT = "step-depresolution"
MONIT_DOWNLOAD = "step-downfinish"
MONIT_INSTALL = "step-installing"
MONIT_FINISH = "step-finish"
MONIT_INSTALLDEB = "step-installdeb"

SOURCE_NAME = {
    'kylin-installer':_("Kylin Installer"),
    'kylin-uninstaller':_("Kylin Uninstaller"),
    'kylin-background-upgrade':_("Kylin Background Upgrade"),
    'kylin-software-center':_("Kylin Software Center"),
}

CALLER = {
    'kylin-installer':"Kylin Installer",
    'kylin-uninstaller':"Kylin Uninstaller",
    'kylin-background-upgrade':"Kylin Background Upgrade",
    'kylin-software-center':"Kylin Software Center",
}

PolicyKit_Authority_Action = {
    'kylin-installer':"cn.kylin.installer.action",
    'kylin-uninstaller':"cn.kylin.uninstaller.action",
    'kylin-software-center':"cn.kylin.software.center.action",
    'kylin-system-updater':"cn.kylinos.KylinSystemUpdater.action",
    'kylin-installer-self':"cn.kylin.installer.self.action",
    'kylin-uninstaller-self':"cn.kylin.uninstaller.self.action",
    'kylin-software-center-self':"cn.kylin.software.center.self.action",
    'kylin-system-updater-self':"cn.kylinos.KylinSystemUpdater.self.action",
}

def get_error_description_from_enum(enum):
    """Get a long description of an error.

    :param enum: The transaction error enum, e.g. :data:`ERROR_NO_LOCK`.
    :returns: The description string.
    """
    try:
        return _DESCS_ERROR[enum]
    except KeyError:
        return get_other_error_description_from_enum(enum)

def get_error_num_from_enum(enum):
    """Get a long description of an error.

    :param enum: The transaction error enum, e.g. :data:`ERROR_NO_LOCK`.
    :returns: The description string.
    """
    try:
        return _CODE_ERROR[enum]
    except KeyError:
        return enum

def get_error_string_from_enum(enum):
    """Get a short description of an error.

    :param enum: The transaction error enum, e.g. :data:`ERROR_NO_LOCK`.
    :returns: The description string.
    """
    try:
        return _STRINGS_ERROR[enum]
    except KeyError:
        return get_other_error_string_from_enum(enum)


def get_source_name_from_enum(enum):
    try:
        return SOURCE_NAME[enum]
    except KeyError:
        return _("Kylin System Updater")

def get_caller_from_enum(enum):
    try:
        return CALLER[enum]
    except KeyError:
        return _("Kylin System Updater")

def get_policykit_authority_action_enum(enum):
    try:
        return PolicyKit_Authority_Action[enum]
    except KeyError:
        if enum.endswith("-self"):
            return "cn.kylinos.KylinSystemUpdater.self.action" #默认配置
        else:
            return "cn.kylinos.KylinSystemUpdater.action" #默认配置

# vim:ts=4:sw=4:et
